    include playerscores.asm
    includesfile myincludes.inc
    dim rand16=a
    dim Clock=b
    dim Joysticks=c
    dim player0score=d
    dim player1score=e
    dim Player0ThrustBit0=f
    dim Player1ThrustBit1=f
    dim ResetHitBit2=f
    dim Direction0=g
    dim Direction1=h
    dim TaggedSoundActive=i
    dim Player0ItBit0=k
    dim Player0Color=l
    dim Player1Color=m

    const taggedsound_length=taggedsound_length
    const p0_color=$48
    const p1_color=$88
    const ballpf_color=$16
    const overheat_color=$0F
    const x_max=144
    const y_max=88
    const y_min=9
    const noscore = 1
    const xstart0=0
    const ystart0=15
    const xstart1=144
    const ystart1=70
    const p_edge_top = 9
    const p_edge_bottom = 88
    const p_edge_left = 1
    const p_edge_right = 145
    const bit0 =     %00000001
    const bit1 =     %00000010
    const bit2 =     %00000100
    const bit3 =     %00001000
    const bit4 =     %00010000
    const bit5 =     %00100000
    const bit6 =     %01000000
    const bit7 =     %10000000
    const bit0mask = %11111110
    const bit1mask = %11111101
    const bit2mask = %11111011
    const bit3mask = %11110111
    const bit4mask = %11101111
    const bit5mask = %11011111
    const bit6mask = %10111111
    const bit7mask = %01111111

Start
    gosub SetColors

    player0y=(rand&63)
    player1y=(rand&63)
    gosub SetSpawnPlayers

    missile0height = 1 : missile1height = 2 : ballheight = 2
    missile1x=player0x+5
    missile1y=player0y-2
    ballx=player1x+5
    bally=player1y-3

    Joysticks=$FF

    gosub SetPlayfield

    player0:
        %00000000
        %00111000
        %01111100
        %01010100
        %01010100
        %00111000
        %00010000
        %00010000
end

    player1:
        %00000000
        %00111000
        %01111100
        %01010100
        %01010100
        %00111000
        %00010000
        %00010000
end

;    playfield:
;    XX.....................X........
;    ................................
;    XX...................X..X.......
;    ................................
;    ..........XX..............XX....
;    ................................
;    .....XX.......XX................
;    ................................
;    X.....................XX........
;    ................................
;    ......XX...................XX...
;end

MainLoop
    Clock=Clock+1
    COLUP0=Player0Color
    COLUP1=Player1Color
    COLUPF=ballpf_color
    NUSIZ0=$05
    NUSIZ1=$35
    CTRLPF=$31
    COLUBK=$F0
    if !switchreset then ResetHitBit2{2}=0: goto ____done_reset
    if ResetHitBit2{2} then ____done_reset
    goto DoReset
____done_reset
    if player0score=$15 || player1score=$15 then goto DoEndGame
    if !TaggedSoundActive then ____skip_tagged_sound
    temp1=TaggedSoundActive-1
    AUDF0=taggedsound[temp1]
    AUDC0=14:AUDV0=12
    TaggedSoundActive=TaggedSoundActive-1
    if !TaggedSoundActive then AUDC0=0:AUDV0=0
    goto ____done_p1_thrust
____skip_tagged_sound
    if pfscore1<>255 then ____skip_p0_overheat
    if !Clock then pfscore1=0:AUDC0=0:AUDV0=0:goto ____skip_p0_overheat
    if Clock{5} then ____skip_p0_white
    Player0Color=$0F
    AUDC0=2:AUDV0=2:AUDF0=0
    goto ____skip_p0_overheat
____skip_p0_white
    gosub SetColors
    AUDC0=2:AUDV0=2:AUDF0=1
____skip_p0_overheat

    if pfscore2<>255 then ____skip_p1_overheat
    if !Clock then pfscore2=0:AUDC1=0:AUDV1=0:goto ____skip_p1_overheat
    if Clock{5} then ____skip_p1_white
    Player1Color=$0F
    AUDC1=2:AUDV1=2:AUDF1=0
    goto ____skip_p1_overheat
____skip_p1_white
    gosub SetColors
    AUDC1=2:AUDV1=2:AUDF1=1
____skip_p1_overheat
    if Clock{0} then ____skip_movement
    gosub CheckCollisions
    if pfscore1 <> 255 then gosub SetSprite0
    if pfscore2 <> 255 then gosub SetSprite1
    gosub MoveSprite
____skip_movement
    if !Clock{0} then goto ____skip_game_logic
    if Clock <> 1 then ____skip_score_it
    if Player0ItBit0{0} then ____skip_score_0
    dec player0score=player0score+1
    goto ____skip_score_it
____skip_score_0
    dec player1score=player1score+1
____skip_score_it
    if (Clock&15) <> 1 then ____skip_check_heat
    if !Player0ThrustBit0{0} then ____skip_p0_heat
    if pfscore1=255 then ____skip_p0_heat
    pfscore1 = pfscore1*2|1
    if pfscore1=255 then Clock=1:Direction0=0
____skip_p0_heat

    if !Player1ThrustBit1{1} then ____skip_p1_heat
    if pfscore2=255 then ____skip_p1_heat
    pfscore2 = pfscore2*2|1
    if pfscore2=255 then Clock=1:Direction1=0
____skip_p1_heat
____skip_check_heat
    if (Clock&31) <> 1 then ____skip_check_cool
    if Player0ThrustBit0{0} || Direction0 then ____skip_p0_cool
    if pfscore1 = 255 then ____skip_p0_cool ; overheating
    if pfscore1 then pfscore1 = pfscore1/2
____skip_p0_cool
    if Player1ThrustBit1{1} || Direction1 then ____skip_p1_cool
    if pfscore2 = 255 then ____skip_p1_cool ; overheating
    if pfscore2 then pfscore2 = pfscore2/2
____skip_p1_cool
____skip_check_cool
____skip_game_logic
    if pfscore1 = 255 then ____done_p0_thrust
    if !Direction0 then ____skip_p0_thrust
    if !joy0fire then ____skip_p0_thrust
    Player0ThrustBit0{0}=1
    AUDC0=8:AUDV0=1:AUDF0=7
    goto ____done_p0_thrust
____skip_p0_thrust
    Player0ThrustBit0{0}=0
    AUDC0=0:AUDV0=0
____done_p0_thrust
    if pfscore2 = 255 then ____done_p1_thrust
    if !Direction1 then ____skip_p1_thrust
    if !joy1fire then ____skip_p1_thrust
    Player1ThrustBit1{1}=1
    AUDC1=8:AUDV1=1:AUDF1=7
    goto ____done_p1_thrust
____skip_p1_thrust
    Player1ThrustBit1{1}=0
    AUDC1=0:AUDV1=0
____done_p1_thrust
    drawscreen
    if !collision(player0, player1) then ____skip_tag
    Player0ItBit0{0}=!Player0ItBit0{0}
    gosub SetColors
    pfscore1=0:pfscore2=0
;    player0x=xstart0
;    player0y=ystart0
;    player1x=xstart1
;    player1y=ystart1
    gosub SetSpawnPlayers
    TaggedSoundActive=taggedsound_length
    Direction0=1:Direction1=1
    gosub SetSprite0
    gosub SetSprite1
    gosub EyeBackground0
    gosub EyeBackground1
    gosub SetPlayfield
____skip_tag
____skip_collision
    goto MainLoop
; End MainLoop

SetPlayfield
    pfclear
    drawscreen
    for temp1=1 to 17
        temp2=(rand&63)
        if temp2>43 then ____skip_iteration
        var0[temp2]=rand
____skip_iteration
    next

    temp1=(rand&7)+2
    temp1=temp1*4
    for temp1=1 to 8
        var0[temp1]=0
        temp1=temp1+1
    next
    return
; End SetPlayfield

SetSpawnPlayers
    if player0y>40 then temp1=ystart0 else temp1=ystart1
    if player1y>40 then temp2=ystart0 else temp2=ystart1
    player0x=xstart0
    player0y=temp1
    player1x=xstart1
    player1y=temp2
    return
; End SetSpawnPlayers

DoReset
    ResetHitBit2{2}=1
    pfscore1=0:pfscore2=0:player0score=0:player1score=0:AUDC0=0:AUDV0=0:AUDC1=0:AUDV1=0:Clock=0
    goto Start
; End DoReset

DoEndGame
    COLUBK=$02
    AUDC0=0:AUDV0=0:AUDC1=0:AUDV1=0
    if joy0fire then goto DoReset
    goto ____done_p1_thrust
; DoEndGame

SetColors
    if Player0ItBit0{0} then ____skip_p1_bright
    Player0Color=$48:player0scorecolor=$48
    Player1Color=$8C:player1scorecolor=$8C
    missile0x=120:missile0y=90
    goto ____done_set_colors
____skip_p1_bright
    Player0Color=$4C:player0scorecolor=$4C
    Player1Color=$88:player1scorecolor=$88
    missile0x=56:missile0y=90
____done_set_colors
    return
; SetColors

CheckCollisions
    Joysticks=SWCHA
    if player0x < 1 || player0x >143 then goto ____done_joy0_collision
; Joystick 0 up collision check
    if (Joysticks&bit4) then ____done_joy0_up
    if player0y <= p_edge_top then ____done_joy0_up
    temp5 = (player0x-5)/4
    temp6 = (player0y-9)/8
    if temp5 < 34 then if pfread(temp5,temp6) then ____stop_joy0_up
    temp4 = (player0x-10)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy0_up
    temp4 = (player0x-14)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy0_up
    temp3 = temp5 - 1
    if temp3 < 34 then if pfread(temp3,temp6) then ____stop_joy0_up
    goto ____done_joy0_up
____stop_joy0_up
    Joysticks=(Joysticks|bit4)
____done_joy0_up
; Joystick 0 down collision check
    if (Joysticks&bit5) then ____done_joy0_down
    if player0y >= p_edge_bottom then goto ____done_joy0_down
    temp5 = (player0x-5)/4
    temp6 = (player0y)/8
    if temp5 < 34 then if pfread(temp5,temp6) then ____stop_joy0_down
    temp4 = (player0x-10)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy0_down
    temp4 = (player0x-14)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy0_down
    temp3 = temp5 - 1
    if temp3 < 34 then if pfread(temp3,temp6) then ____stop_joy0_down
    goto ____done_joy0_down
____stop_joy0_down
    Joysticks=(Joysticks|bit5)
____done_joy0_down

; Joystick 0 left collision check
    if (Joysticks&bit6) then ____done_joy0_left
    if player0x <= p_edge_left then ____done_joy0_left
    temp5 = (player0y-1)/8
    temp6 = (player0x-18)/4
    if temp6 < 34 then if pfread(temp6,temp5) then ____stop_joy0_left
    temp3 = (player0y-8)/8
    if temp6 < 34 then if pfread(temp6,temp3) then ____stop_joy0_left
    goto ____done_joy0_left
____stop_joy0_left
    Joysticks=(Joysticks|bit6)
____done_joy0_left

; Joystick 0 right collision check
    if (Joysticks&bit7) then ____done_joy0_right
    if player0x >= p_edge_right then ____done_joy0_right
    temp5 = (player0y-1)/8
    temp6 = (player0x-0)/4
    if temp6 < 34 then if pfread(temp6,temp5) then ____stop_joy0_right
    temp3 = (player0y-8)/8
    if temp6 < 34 then if pfread(temp6,temp3) then ____stop_joy0_right
    goto ____done_joy0_right
____stop_joy0_right
    Joysticks=(Joysticks|bit7)
____done_joy0_right

____done_joy0_collision

    if player1x < 1 || player1x >143 then goto ____done_joy1_collision
; Joystick 1 up collision check
    if (Joysticks&bit0) then ____done_joy1_up
    if player1y <= p_edge_top then ____done_joy1_up
    temp5 = (player1x-5)/4
    temp6 = (player1y-9)/8
    if temp5 < 34 then if pfread(temp5,temp6) then ____stop_joy1_up
    temp4 = (player1x-10)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy1_up
    temp4 = (player1x-14)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy1_up
    temp3 = temp5 - 1
    if temp3 < 34 then if pfread(temp3,temp6) then ____stop_joy1_up
    goto ____done_joy1_up
____stop_joy1_up
    Joysticks=(Joysticks|bit0)
____done_joy1_up

; Joystick 1 down collision check
    if (Joysticks&bit1) then ____done_joy1_down
    if player1y >= p_edge_bottom then goto ____done_joy1_down
    temp5 = (player1x-5)/4
    temp6 = (player1y)/8
    if temp5 < 34 then if pfread(temp5,temp6) then ____stop_joy1_down
    temp4 = (player1x-10)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy1_down
    temp4 = (player1x-14)/4
    if temp4 < 34 then if pfread(temp4,temp6) then ____stop_joy1_down
    temp3 = temp5 - 1
    if temp3 < 34 then if pfread(temp3,temp6) then ____stop_joy1_down
    goto ____done_joy1_down
____stop_joy1_down
    Joysticks=(Joysticks|bit1)
____done_joy1_down

; Joystick 1 left collision check
    if (Joysticks&bit2) then ____done_joy1_left
    if player1x <= p_edge_left then ____done_joy1_left
    temp5 = (player1y-1)/8
    temp6 = (player1x-18)/4
    if temp6 < 34 then if pfread(temp6,temp5) then ____stop_joy1_left
    temp3 = (player1y-8)/8
    if temp6 < 34 then if pfread(temp6,temp3) then ____stop_joy1_left
    goto ____done_joy1_left
____stop_joy1_left
    Joysticks=(Joysticks|bit2)
____done_joy1_left

; Joystick 1 right collision check
    if (Joysticks&bit3) then ____done_joy1_right
    if player1x >= p_edge_right then ____done_joy1_right
    temp5 = (player1y-1)/8
    temp6 = (player1x-0)/4
    if temp6 < 34 then if pfread(temp6,temp5) then ____stop_joy1_right
    temp3 = (player1y-8)/8
    if temp6 < 34 then if pfread(temp6,temp3) then ____stop_joy1_right
    goto ____done_joy1_right
____stop_joy1_right
    Joysticks=(Joysticks|bit3)
____done_joy1_right
____done_joy1_collision

    return
; End CheckCollisions

SetDirection
    if pfscore1=255 then goto ____end_joy0_direction
    temp1=Joysticks/16
    on temp1 goto ____none0 ____none0 ____none0 ____none0 ____none0 ____downright0 ____upright0 ____right0 ____none0 ____downleft0 ____upleft0 ____left0 ____none0 ____down0 ____up0 ____none0
____up0
    Direction0=1
    goto ____end_joy0_direction
____upright0
    Direction0=2
    goto ____end_joy0_direction
____right0
    Direction0=3
    goto ____end_joy0_direction
____downright0
    Direction0=4
    goto ____end_joy0_direction
____down0
    Direction0=5
    goto ____end_joy0_direction
____downleft0
    Direction0=6
    goto ____end_joy0_direction
____left0
    Direction0=7
    goto ____end_joy0_direction
____upleft0
    Direction0=8
    goto ____end_joy0_direction
____none0
    Direction0=0
____end_joy0_direction

    if pfscore2=255 then goto ____end_joy1_direction
    temp1=(Joysticks&$0F)
    on temp1 goto ____none1 ____none1 ____none1 ____none1 ____none1 ____downright1 ____upright1 ____right1 ____none1 ____downleft1 ____upleft1 ____left1 ____none1 ____down1 ____up1 ____none1
____up1
    Direction1=1
    goto ____end_joy1_direction
____upright1
    Direction1=2
    goto ____end_joy1_direction
____right1
    Direction1=3
    goto ____end_joy1_direction
____downright1
    Direction1=4
    goto ____end_joy1_direction
____down1
    Direction1=5
    goto ____end_joy1_direction
____downleft1
    Direction1=6
    goto ____end_joy1_direction
____left1
    Direction1=7
    goto ____end_joy1_direction
____upleft1
    Direction1=8
    goto ____end_joy1_direction
____none1
    Direction1=0
____end_joy1_direction
    return
; End SetDirection

SetSprite0
    on Direction0 goto ____end_sprite0 ____spriteup0 ____spriteupright0 ____spriteright0 ____spritedownright0 ____spritedown0 ____spritedownleft0 ____spriteleft0 ____spriteupleft0
____spriteup0
    player0:
        %00000000
        %00111000
        %01111100
        %01010100
        %01010100
        %00111000
        %00010000
        %00010000
end
    goto ____end_sprite0
____spriteupright0
    player0:
        %00000000
        %00110000
        %01111000
        %11101100
        %11010100
        %01101000
        %00110100
        %00000010
end
    goto ____end_sprite0
____spriteright0
    player0:
        %00000000
        %00000000
        %00111000
        %01100100
        %01111111
        %01100100
        %00111000
        %00000000
end
    goto ____end_sprite0
____spritedownright0
    player0:
        %00000010
        %00110100
        %01101000
        %11010100
        %11101100
        %01111000
        %00110000
        %00000000
end
    goto ____end_sprite0
____spritedown0
    player0:
        %00010000
        %00010000
        %00111000
        %01010100
        %01010100
        %01111100
        %00111000
        %00000000
end
    goto ____end_sprite0
____spritedownleft0
    player0:
        %10000000
        %01011000
        %00101100
        %01010110
        %01101110
        %00111100
        %00011000
        %00000000
end
    goto ____end_sprite0
____spriteleft0
    player0:
        %00000000
        %00000000
        %00011100
        %00100110
        %11111110
        %00100110
        %00011100
        %00000000
end
    goto ____end_sprite0
____spriteupleft0
    player0:
        %00000000
        %00011000
        %00111100
        %01101110
        %01010110
        %00101100
        %01011000
        %10000000
end
____end_sprite0
    return
; End SetSprite0

SetSprite1
    on Direction1 goto ____end_sprite1 ____spriteup1 ____spriteupright1 ____spriteright1 ____spritedownright1 ____spritedown1 ____spritedownleft1 ____spriteleft1 ____spriteupleft1
____spriteup1
    player1:
        %00000000
        %00111000
        %01111100
        %01010100
        %01010100
        %00111000
        %00010000
        %00010000
end
    goto ____end_sprite1
____spriteupright1
    player1:
        %00000000
        %00110000
        %01111000
        %11101100
        %11010100
        %01101000
        %00110100
        %00000010
end
    goto ____end_sprite1
____spriteright1
    player1:
        %00000000
        %00000000
        %00111000
        %01100100
        %01111111
        %01100100
        %00111000
        %00000000
end
    goto ____end_sprite1
____spritedownright1
    player1:
        %00000010
        %00110100
        %01101000
        %11010100
        %11101100
        %01111000
        %00110000
        %00000000
end
    goto ____end_sprite1
____spritedown1
    player1:
        %00010000
        %00010000
        %00111000
        %01010100
        %01010100
        %01111100
        %00111000
        %00000000
end
    goto ____end_sprite1
____spritedownleft1
    player1:
        %10000000
        %01011000
        %00101100
        %01010110
        %01101110
        %00111100
        %00011000
        %00000000
end
    goto ____end_sprite1
____spriteleft1
    player1:
        %00000000
        %00000000
        %00011100
        %00100110
        %11111110
        %00100110
        %00011100
        %00000000
end
    goto ____end_sprite1
____spriteupleft1
    player1:
        %00000000
        %00011000
        %00111100
        %01101110
        %01010110
        %00101100
        %01011000
        %10000000
end
____end_sprite1
    return
; End SetSprite1

MoveSprite
    if Player0ThrustBit0{0} && !(Clock&3) then temp6=2 else temp6=1
    if Player1ThrustBit1{1} && !(Clock&3) then temp7=2 else temp7=1
    if pfscore1=255 then goto ____end_missile_move0
    on Direction0 goto ____end_missile_move0 ____moveup0 ____moveupright0 ____moveright0 ____movedownright0 ____movedown0 ____movedownleft0 ____moveleft0 ____moveupleft0
____moveup0
    player0y = player0y - temp6
    goto ____end_move0
____moveupright0
    player0y = player0y - temp6
    player0x = player0x + temp6
    goto ____end_move0
____moveright0
    player0x = player0x + temp6
    goto ____end_move0
____movedownright0
    player0y = player0y + temp6
    player0x = player0x + temp6
    goto ____end_move0
____movedown0
    player0y = player0y + temp6
    goto ____end_move0
____movedownleft0
    player0y = player0y + temp6
    player0x = player0x - temp6
    goto ____end_move0
____moveleft0
    player0x = player0x - temp6
    goto ____end_move0
____moveupleft0
    player0y = player0y - temp6
    player0x = player0x - temp6
____end_move0
    if player0x>200 then player0x=0
    if player0x>x_max then player0x=x_max
    if player0y>y_max then player0y=y_max
    if player0y<y_min then player0y=y_min
    gosub EyeBackground0
____end_missile_move0

    if pfscore2=255 then goto ____end_missile_move1
    on Direction1 goto ____end_missile_move1 ____moveup1 ____moveupright1 ____moveright1 ____movedownright1 ____movedown1 ____movedownleft1 ____moveleft1 ____moveupleft1
____moveup1
    player1y = player1y - temp7
    goto ____end_move1
____moveupright1
    player1y = player1y - temp7
    player1x = player1x + temp7
    goto ____end_move1
____moveright1
    player1x = player1x + temp7
    goto ____end_move1
____movedownright1
    player1y = player1y + temp7
    player1x = player1x + temp7
    goto ____end_move1
____movedown1
    player1y = player1y + temp7
    goto ____end_move1
____movedownleft1
    player1y = player1y + temp7
    player1x = player1x - temp7
    goto ____end_move1
____moveleft1
    player1x = player1x - temp7
    goto ____end_move1
____moveupleft1
    player1y = player1y - temp7
    player1x = player1x - temp7
____end_move1
    if player1x>200 then player1x=0
    if player1x>x_max then player1x=x_max
    if player1y>y_max then player1y=y_max
    if player1y<y_min then player1y=y_min
    gosub EyeBackground1
____end_missile_move1
    return
; End MoveSprite

EyeBackground0
    missile1x=player0x+bg_x_offset[Direction0]
    missile1y=player0y-bg_y_offset[Direction0]
    return
; End EyeBackground0

EyeBackground1
    ballx=player1x+bg_x_offset[Direction1]
    bally=player1y-bg_y_offset[Direction1]-1
    return
; End EyeBackground1

    vblank
    gosub SetDirection
    return
; End

    data bg_x_offset
    0, 6, 4, 4, 4, 4, 6, 6, 6
end

    data bg_y_offset
    0, 2, 3, 3, 2, 3, 2, 3, 3
end

    data taggedsound
    2, 2, 2, 2, 4, 4, 5, 5
end